module Fibonacci where

import Array

fib_naive :: Int -> Integer
fib_naive n = fib n
            where fib 0 = 1
                  fib 1 = 1
                  fib n = fib (n-1) + fib (n-2)


fib_list :: Int -> Integer
fib_list n = fib !! n
           where fib = 1:1:map (\i -> fib!!(i-1) + fib!!(i-2)) [2..]

fib_array :: Int -> Integer
fib_array n = fib!n
            where fib = array (0,n) ([(0,1),(1,1)]++[(i,fib!(i-1) + fib!(i-2)) | i <- [2..n]])

fib_good :: Int -> Integer
fib_good n = fib 0 1 n
           where fib x y 0 = y
                 fib x y n = fib y (x+y) (n-1)

